package djmil.cordacheckers.cordaclient.dao.flow.arguments;

import djmil.cordacheckers.cordaclient.dao.GameState;
import djmil.cordacheckers.cordaclient.dao.flow.RequestBody;

public record RspGameState(
    GameState successStatus, 
    String transactionId,
    String failureStatus) implements Rsp<GameState> {
    
    @Override
    public GameState getResponce(RequestBody requestBody) {
        if (failureStatus() != null) {
            final String msg = requestBody.flowClassName() +" requestId " +requestBody.clientRequestId() +" has failed";
            System.err.println(msg +". Reson " +failureStatus +". TransactionId " +transactionId);
            throw new RuntimeException(msg);
        }

        System.out.println("[OK] "+transactionId);
        return successStatus();
    }
}
